{% extends "base.html" %}
{% load humanize %}

{% block title %} - {% trans "Новое наблюдение" %} {% endblock %}

{% block css %}
<link rel="stylesheet"
  href="{% static 'lib/bootstrap-select/dist/css/bootstrap-select.min.css' %}">
<link rel="stylesheet"
  href="{% static 'lib/@eonasdan/tempus-dominus/dist/css/tempus-dominus.min.css' %}">
<link rel="stylesheet"
  href="{% static 'lib/jquery-ui/dist/themes/base/jquery-ui.min.css' %}">
<link rel="stylesheet"
  type="text/scss"
  href="{% static 'css/pages/observation_new.scss' %}">
{% endblock css %}

{% block body-class %}class="observations_new"{% endblock %}

{% block content %}
<section class="container block-h1">
  <div class="btn-back"><a href="{% url 'base:observations_list' %}">{% trans "Назад" %}</a></div>
  <h1>{% trans "Новое наблюдение" %}</h1>
  <div class="row subtitle">
    <div class="utc-text"><span class="bi bi-clock"> {% trans "Время указано в UTC" %}</span></div>
    <a class="btn btn-small btn-outline-blue"
      role="button"
      data-toggle="modal"
      data-target="#HotkeysModal"
      data-target-type="modal">
      <span class="bi bi-fire"
        aria-hidden="true"
        data-toggle="tooltip"
        title="{% trans 'Горячие клавиши' %}"></span>
    </a>
  </div>
</section>
<section class="tables-filtering container">
  <form role="form"
    class="tables-filtering__form"
    action="{% url 'base:observation_new' %}"
    method="post"
    data-obs-filter="{{ obs_filter.exists|lower }}"
    data-obs-filter-station="{{ obs_filter.ground_station }}"
    data-obs-filter-dates="{{ obs_filter.dates|lower }}"
    data-obs-filter-transmitter="{{ obs_filter.transmitter }}"
    data-obs-filter-satellite="{{ obs_filter.norad }}"
    id="form-obs">{% csrf_token %}
    <div class="row"
      id="collapse-options">
      <div class="form-group col">
        <label>{% trans "Спутник" %}
          {% if obs_filter.norad %}
          {% for satellite in satellites %}
          {% if satellite.norad_cat_id == obs_filter.norad %}
          <select id="satellite-selection"
            class="form-control selectpicker"
            data-style="btn"
            name="satellite"
            autocomplete="off"
            data-size="10"
            disabled>
            <option data-norad="{{ satellite.norad_cat_id }}"
              value="{{ satellite.norad_cat_id }}"
              selected>
              {{ satellite.norad_cat_id }} - {{ satellite.name }}
            </option>
          </select>
          <input type="hidden"
            name="satellite"
            value="{{ satellite.norad_cat_id }}">
          {% endif %}
          {% endfor %}
          {% else %}
          <select id="satellite-selection"
            class="form-control selectpicker"
            data-style="btn"
            name="satellite"
            data-live-search="true"
            data-size="10"
            autocomplete="off">
            <option value=""
              selected
              disabled>{% trans "Выберите спутник" %}</option>
            {% for satellite in satellites %}
            <option data-norad="{{ satellite.norad_cat_id }}"
              value="{{ satellite.norad_cat_id }}">
              {{ satellite.norad_cat_id }} - {{ satellite.name }}
            </option>
            {% endfor %}
          </select>
          {% endif %}
        </label>
        <label class="transmitters-label">{% trans "Передатчик" %}
          <div class="loading-spinner transmitters-spinner">
            <div class="spinner">
              <div class="bounce1"></div>
              <div class="bounce2"></div>
              <div class="bounce3"></div>
            </div>
          </div>
          <select id="transmitter-selection"
            class="form-control selectpicker"
            data-style="btn"
            disabled
            data-size="10"
            name="transmitter"
            autocomplete="off">
            <option id="no-transmitter"
              value=""
              selected>{% trans "Не выбран спутник" %}</option>
          </select>
        </label>
        <label id="center-frequency-formgroup"
          style="display: none;">{% trans "Центральная частота (Гц)" %}
          <div>
            <input data-is-valid="false"
              id="center-frequency-input"
              step="1"
              class="form-control w-100"
              type="number"
              min="1"
              autocomplete="off">
            <span id="frequency-input-format"></span>
          </div>
        </label>
        <label class="stations-label">{% trans "Станции" %}
          <div class="loading-spinner stations-spinner">
            <div class="spinner">
              <div class="bounce1"></div>
              <div class="bounce2"></div>
              <div class="bounce3"></div>
            </div>
          </div>
          <div id="station-field">
            <select id="station-selection"
              class="form-control selectpicker"
              data-style="btn"
              name="station"
              autocomplete="off"
              multiple
              data-none-selected-text="{% trans 'Не выбрано' %}"
              data-live-search="true"
              data-count-selected-text="{% trans 'Выбрано' %} {0} {% trans 'из' %} {1} {% trans 'станций' %}"
              data-dropup-auto="false"
              data-size="10"
              data-selected-text-format="count"
              data-actions-box="true"
              data-select-all-text="{% trans 'Выбрать все' %}"
              data-deselect-all-text="{% trans 'Очистить' %}"
              data-actions-btn-style="btn-red"
              disabled>
              <option id="no-station"
                value=""
                selected>{% trans "Нет подходящих станций" %}</option>
            </select>
          </div>
        </label>
      </div>
      <div class="form-group col">
        <label>{% trans "Время начала" %}
          <div class='input-group datetimepicker'
            id="datetimepicker-start"
            data-date-minstart="{{ date_min_start }}"
            data-td-target-input="nearest"
            data-td-target-toggle="nearest">
            {% if obs_filter.dates %}
            <input id="datetimepicker-start"
              data-td-target="#datetimepicker-start"
              type="text"
              class="form-control"
              name="start"
              value="{{ obs_filter.start}}">
            {% else %}
            <input id="datetimepicker-start"
              data-td-target="#datetimepicker-start"
              type="text"
              class="form-control"
              name="start"
              autocomplete="off">
            {% endif %}
            <span class="input-group-append"
              data-td-target="#datetimepicker-start"
              data-td-toggle="datetimepicker">
              <i class="input-group-text bi bi-calendar3"></i>
            </span>
          </div>
        </label>
        <label>{% trans "Время окончания" %}
          <div class='input-group datetimepicker'
            id="datetimepicker-end"
            data-date-maxrange="{{ date_max_range }}"
            data-date-minend="{{ date_min_end }}"
            data-td-target-input="nearest"
            data-td-target-toggle="nearest">
            {% if obs_filter.dates %}
            <input data-td-target="#datetimepicker-end"
              type="text"
              class="form-control"
              name="end"
              data-td-target="#datetimepicker-end"
              value="{{ obs_filter.end}}">
            {% else %}
            <input data-td-target="#datetimepicker-end"
              type="text"
              class="form-control"
              name="end"
              autocomplete="off">
            {% endif %}
            <span class="input-group-append"
              data-td-target="#datetimepicker-start"
              data-td-toggle="datetimepicker">
              <i class="input-group-text bi bi-calendar3"></i>
            </span>
          </div>
        </label>
      </div>
    </div>
    <div class="more-settings">
      <a role="button"
        id="advanced-options"
        class="btn btn-sm more-settings-btn">
        {% trans "Показать больше настроек" %}
      </a>
      <div class="more-options">
        <div class="row">
          <div class="col title">{% trans "Горизонт станции" %}</div>
          <div class="col buttons"
            id="horizon-status">
            <label class="btn btn-sm btn-outline-gray active"
              id="default-horizon">
              <input type="radio"
                name="horizon"
                value="default"
                autocomplete="off"
                checked>
              {% trans "Минимум станции" %}
            </label>
            <label class="btn btn-sm btn-outline-gray"
              id="custom-horizon">
              <input type="radio"
                name="horizon"
                value="custom"
                autocomplete="off">
              {% trans "Установить свой" %}
            </label>
          </div>
        </div>
        <div class="row">
          <div class="col title">{% trans "Наложенные" %}</div>
          <div class="col buttons"
            id="overlapped">
            <label class="btn btn-sm btn-outline-gray active"
              id="hide-overlapped">
              <input type="radio"
                name="overlapped"
                value="hide-overlapped"
                autocomplete="off"
                checked>
              {% trans "Спрятать" %}
            </label>
            <label class="btn btn-sm btn-outline-gray"
              id="truncate-overlapped">
              <input type="radio"
                name="overlapped"
                value="truncate-overlapped"
                autocomplete="off">
              {% trans "Показать усеченные" %}
            </label>
          </div>
        </div>
        <div id="split-duration-formgroup"
          class="row">
          <div class="col title">{% trans "Длительность промежутка" %}</div>
          <div class="col buttons"
            id="split-duration-status">
            <label class="btn btn-sm btn-outline-gray active"
              id="default-split-duration">
              <input type="radio"
                name="split_duration"
                value="{{ split.duration }}"
                data-min="{{ obs_min_duration }}"
                autocomplete="off"
                checked>
              {% trans "По-умолчанию" %} ({{ split.duration }}{%trans "с" %})
            </label>
            <label class="btn btn-sm btn-outline-gray"
              id="custom-split-duration">
              <input type="radio"
                name="split_duration"
                value="custom"
                autocomplete="off">
              {% trans "Произвольное" %}
            </label>
          </div>
        </div>
        <div class="row">
          <div class="col title">{% trans "Длительность разбивки" %}</div>
          <div class="col buttons"
            id="break-duration-status">
            <label class="btn btn-sm btn-outline-gray active"
              id="default-break-duration">
              <input type="radio"
                name="break_duration"
                value="{{ split.break }}"
                autocomplete="off"
                checked>
              {% trans "По-умолчанию" %} ({{ split.break }}{% trans "с" %})
            </label>
            <label class="btn btn-sm btn-outline-gray"
              id="custom-break-duration">
              <input type="radio"
                name="break_duration"
                value="custom"
                autocomplete="off">
              {% trans "Произвольное" %}
            </label>
          </div>
        </div>
      </div>
    </div>

    {% if obs_filter.ground_station %}
    <input type="hidden"
      name="ground_station"
      value="{{ obs_filter.ground_station }}">
    {% endif %}

    <div class="row calculate-btn justify-content-end">
      <button type="button"
        id="calculate-observation"
        class="btn btn-sm btn-blue">
        <i class="bi bi-calculator-fill"
          aria-hidden="true"></i>
        {% trans "Рассчитать" %}
      </button>
    </div>

    <div class="calculation-result">
      <h3>{% trans "Время для расчета" %}</h3>
      <div id="obs-selection-tools"
        class="row align-items-center">
        <div class="col select-cnt">
          <button type="button"
            id="select-all-observations"
            class="btn btn-sm btn-outline-gray"><i class="bi bi-square"> {%trans "Все" %}</i></button>
          <button type="button"
            id="select-none-observations"
            class="btn btn-sm btn-outline-gray"><i class="bi bi-square"> {% trans "Ни одного" %}</i></button>
        </div>
        <div class="col elevation">
          <label for="scheduling-elevation-filter">{% trans "Максимальная элевация" %}</label>
          <div class="slider-wrapper">
            <input id="scheduling-elevation-filter"
              type="text">
          </div>
        </div>
      </div>
      <div class="loading-spinner notice">
        <div class="spinner">
          <div class="bounce1"></div>
          <div class="bounce2"></div>
          <div class="bounce3"></div>
        </div>
        {% trans "Производится расчет" %}
      </div>
      <div class="loading-spinner scheduling">
        <div class="spinner">
          <div class="bounce1"></div>
          <div class="bounce2"></div>
          <div class="bounce3"></div>
        </div>
        {% trans "Планирование наблюдений" %}
      </div>
      <div id="timeline"></div>
      <div id="windows-data"></div>
    </div>

    <div id="schedule-selection"
      class="row calculation-result">
      <button type="button"
        id="schedule-observation"
        class="btn btn-big btn-outline-green">
        <i class="bi bi-calendar2-range"
          aria-hidden="true"></i>
        {% trans "Запланировать" %}
      </button>
      <div class="col">
        <div id="selected-observations"></div>
      </div>
      <div id="hover-obs">
        <div class="row">
          <div class="obs-details col">
            <div class="row">
              <strong id="name"
                class="bold-text"></strong>
            </div>
            <div class="row">
              <div class="bold-text">{% trans "Время начала" %}: </div>
              <div id="start"></div>
            </div>
            <div class="row">
              <div class="bold-text">{% trans "Время конца" %}: </div>
              <div id="end"></div>
            </div>
            <div class="row">
              <div class="bold-text"
                id="details"></div>
            </div>
          </div>
          <svg xmlns="http://www.w3.org/2000/svg"
            version="1.1"
            id="polar"
            class="col"
            width="100px"
            height="100px"
            viewBox="-110 -110 220 220"
            overflow="hidden">
          </svg>
        </div>
      </div>
    </div>
  </form>
</section>

{% endblock content %}


{% block modal %}

<!-- Confirmation Modal -->
<div class="modal fade"
  id="confirm-modal"
  tabindex="-1"
  role="dialog"
  aria-labelledby="ConfirmModalTitle">
  <div class="modal-dialog modal-md"
    role="document">
    <div class="modal-content">
      <div class="modal-header align-items-center">
        <strong>
          {% trans "Вы действительно хотите запланировать" %} <span class="counted-obs"></span>
          {% trans "наблюдений?" %}
        </strong>
      </div>
      <div class="modal-body">
        <p>{% trans "ВНИМАНИЕ: Вы хотите запланировать" %} <span class="counted-obs"></span>{% trans " набл. на" %}
          <span class="counted-stations"></span> {% trans " разных ст." %}
        </p>
        <p>{% trans "Несколько владельцев станций добавили запросы в описание их станций." %}
      </div>
      <div class="modal-footer">
        <button type="button"
          class="btn btn-small btn-red"
          data-dismiss="modal">{% trans "Отменить" %}</button>
        <button type="submit"
          id="modal-schedule-observation"
          class="btn btn-small btn-green">
          {% trans "Запланировать" %}
        </button>
      </div>
    </div>
  </div>
</div>

<!-- Hotkeys Modal -->
{% include 'includes/observation-new-hotkeys.html' %}

{% endblock modal %}

{% block javascript %}
<script src="{% static 'lib/d3/dist/d3.min.js' %}"></script>
<script src="{% static 'lib/moment/min/moment.min.js' %}"></script>
<script src="{% static 'lib/jquery-ui-touch-punch/jquery.ui.touch-punch.min.js' %}"></script>
<script src="{% static 'lib/@popperjs/core/dist/umd/popper.min.js' %}"></script>
<script src="{% static 'lib/@eonasdan/tempus-dominus/dist/js/tempus-dominus.min.js' %}"></script>
<script src="{% static 'lib/@eonasdan/tempus-dominus/dist/plugins/customDateFormat.js' %}"></script>
<script src="{% static 'lib/bootstrap-slider/dist/bootstrap-slider.min.js' %}"></script>
<script src="{% static 'lib/bootstrap-select/dist/js/bootstrap-select.min.js' %}"></script>
<script src="{% static 'lib/satellite.js/dist/satellite.min.js' %}"></script>
<script src="{% static 'js/utc.js' %}"></script>
<script src="{% static 'js/polar_svg.js' %}"></script>
<script src="{% static 'js/observation_new.js' %}"></script>
{% endblock javascript %}